"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModeratedState = void 0;
const DraftState_1 = require("./DraftState");
const PublishedState_1 = require("./PublishedState");
const State_1 = require("./State");
class ModeratedState extends State_1.State {
    draft() {
        console.log('Документ отправлен на повторную подготовку');
        this.document.changeState(new DraftState_1.DraftState());
    }
    moderate() {
        console.log('Документ уже находится в модерации');
    }
    publish() {
        if (this.document.currentUser === "admin") {
            console.log('Отправляем документ на публикацию');
            this.document.changeState(new PublishedState_1.PublishedState());
        }
        else {
            console.log('У вас нет прав на публикацию');
        }
    }
}
exports.ModeratedState = ModeratedState;
