import { ShipCreator } from "./factory-pattern/factory/ShipCreator";
import { TransportCreator } from "./factory-pattern/factory/TransportCreator";
import { TruckCreator } from "./factory-pattern/factory/TruckCreator";
import { UserDocument } from "./state-pattern/UserDocument";
import { Context } from "./strategy-pattern/Context";
import { AddStrategy } from "./strategy-pattern/strategy/AddStrategy";
import { MultiplyStrategy } from "./strategy-pattern/strategy/MultiplyStrategy";
import { SubstractStrategy } from "./strategy-pattern/strategy/SubstractStrategy";

function clientCode(creator: TransportCreator) {
  let isTruck = true;

  const country = "Kazakhstan";
  const goods = ["bmw", "zeekr"];
  creator.transfer(country, goods);

  // if (isTruck) {
  //   const truck = new Truck();
  //   truck.transfer(country, goods);
  // } else {
  //   const ship = new Ship();
  //   ship.transfer(country, goods);
  // } 
}

// console.log('Запускается реализация для сухопутной перевозки');
// clientCode(new TruckCreator());

// console.log('Запускается реализация для морской перевозки');
// clientCode(new ShipCreator());

// const doc: UserDocument = new UserDocument("admin");
// doc.sendForModeration();
// doc.sendForModeration();

// doc.sendForPublication();
// doc.sendForDraft();


let action = "add";
let context = new Context();

if (action === "add") {
  context.setStrategy(new AddStrategy());
} else if (action === "subsctract") {
  context.setStrategy(new SubstractStrategy());
} else {
  context.setStrategy(new MultiplyStrategy());
}

const result = context.execute(5, 3);
console.log(result);
